#include <string>
#include <string.h>
#include <vector>

using namespace std;

string Replace(char *szText, char *szChange, char *szTo)
{
    string myString;
    string text=szText, Change=szChange, to=szTo;

    if(text.size()<Change.size())
        return text;
    else if(text==Change)
        return to;

    for(unsigned i=0; i<text.size()-Change.size(); i++)
    {
        if(text.substr(i, Change.size())==Change)
        {
            myString+=to;
            i+=Change.size()-1;
        }
        else
            myString+=text[i];
    }

    myString+=text.substr(i);
    return myString;
}

vector<string> Split(char *szText, char *szSplit)
{
    vector<string> vResult;
    string szWhole=szText;

    unsigned int nPosition;
    unsigned int nLength=string(szSplit).size();

    while((nPosition=szWhole.find(szSplit))!=0xffffffff)
    {
        string temp=szWhole.substr(0, nPosition);
        szWhole=szWhole.substr(nPosition+nLength);
        vResult.push_back(temp);
    }

    if(szWhole.size())
        vResult.push_back(szWhole);

    return vResult;
}

string ltrim(char *szText)
{
    string back;
    string text=szText;
    unsigned int textLength=text.size();

    if(textLength==0)
    {
        back="";
        return back;
    }

    unsigned int i=-1;
    while(text[++i]==32);

    back=text.substr(i);
    return back;
}

string rtrim(char *szText)
{
    string back;
    string text=szText;
    char *tmp;
    unsigned int textLength=text.size();

    if(textLength==0)
    {
        back="";
        return back;
    }

    textLength++;
    while(text[(--textLength)-1]==32);

    tmp=new char[textLength+1];
    strncpy(tmp, text.c_str(), textLength);
    tmp[textLength]='\0';

    back=tmp;
    delete[] tmp;
    return back;
}

string trim(char *szText)
{
    return ltrim((char *) rtrim(szText).c_str());
}

string HtmlEncode(char *szText)
{
    string szResult=szText;
    szResult=Replace((char *)szResult.c_str(), "&", "&amp;");
    szResult=Replace((char *)szResult.c_str(), "<", "&lt;");
    szResult=Replace((char *)szResult.c_str(), ">", "&gt;");
    szResult=Replace((char *)szResult.c_str(), "\"", "&quot;");
    return szResult;
}

string HtmlDecode(char *szText)
{
    string szResult=szText;
    szResult=Replace((char *)szResult.c_str(), "&quot;", "\"");
    szResult=Replace((char *)szResult.c_str(), "&lt;", "<");
    szResult=Replace((char *)szResult.c_str(), "&gt;", ">");
    szResult=Replace((char *)szResult.c_str(), "&amp;", "&");
    return szResult;
}
