// EmuCall.cpp : implementation file
//

#include "stdafx.h"
#include "TeleMan.h"
#include "EmuCall.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EmuCall dialog


EmuCall::EmuCall(CWnd* pParent /*=NULL*/)
    : CDialog(EmuCall::IDD, pParent)
{
    //{{AFX_DATA_INIT(EmuCall)
    m_CalledNum = _T("");
    //}}AFX_DATA_INIT
}


void EmuCall::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(EmuCall)
    DDX_Control(pDX, IDC_EDIT_CALL, m_EditCall);
    DDX_Control(pDX, ID_BTN_HR, m_BtnHR);
    DDX_Control(pDX, ID_BTN_HH, m_BtnHH);
    DDX_Control(pDX, IDC_COMBO_SELF, m_ComboSelf);
    DDX_Control(pDX, IDC_BTN_OR, m_BtnOR);
    DDX_Control(pDX, IDC_BTN_OH, m_BtnOH);
    DDX_Text(pDX, IDC_EDIT_CALL, m_CalledNum);
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(EmuCall, CDialog)
    //{{AFX_MSG_MAP(EmuCall)
    ON_BN_CLICKED(ID_BTN_HR, OnBtnHr)
    ON_BN_CLICKED(IDC_BTN_OR, OnBtnOr)
    ON_BN_CLICKED(IDC_BTN_OH, OnBtnOh)
    ON_BN_CLICKED(ID_BTN_HH, OnBtnHh)
    ON_CBN_SELCHANGE(IDC_COMBO_SELF, OnSelchangeComboSelf)
    ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EmuCall message handlers

void EmuCall::OnBtnHr()
{
    // TODO: Add your control notification handler code here
    UpdateData();
    if(m_CalledNum=="")
    {
        MessageBox("еĺ", "绰Ʒѳ", MB_ICONINFORMATION);
        return;
    }

    XmlDatabase online;
    online.LoadFromFile("Online.xdb");
    CString cCondition="Account='";

    if(m_CalledNum.Left(6)=="179090")
        cCondition+=m_CalledNum.Mid(5);
    else
        cCondition+=m_CalledNum;

    cCondition+="'";
    if(online.Filter((char *)(LPCTSTR)cCondition, "Account").GetCount())
    {
        MessageBox("Բ𣬶Էͨ", "绰ѳ", MB_ICONINFORMATION);
        return;
    }

    string szJudge;
    bool flag=false;
    XmlDatabase MyDB;
    XmlDatabase FCDB;
    MyDB.LoadFromFile("Account.xdb");
    FCDB.LoadFromFile("FreeCall.xdb");
    cCondition="Account='";
    cCondition+=m_CalledNum;
    cCondition+="'";
    szJudge=m_CalledNum.Mid(0, 6);
    nMode=0;
    //жϲ绰
    if (szJudge=="179090")
    {
        flag=true;
        nMode=3;
    }
    if (m_CalledNum[0]=='0')
    {
        flag=true;
        nMode=2;
    }
    if(MyDB.Filter((char *)(LPCTSTR)cCondition, "Account").GetCount()!=0)
    {
        flag=true;
        nMode=1;
    }
    if(FCDB.Filter((char *)(LPCTSTR)cCondition,"Account").GetCount()!=0)
    {
        flag=true;
        nMode=4;
    }
    if(flag)
    {
        m_BtnOR.EnableWindow(TRUE);
        m_BtnHR.EnableWindow(FALSE);
    }
    else
        MessageBox("еĺ", "绰Ʒѳ", MB_ICONINFORMATION);

    m_EditCall.EnableWindow(FALSE);
    m_ComboSelf.EnableWindow(FALSE);
}

void EmuCall::OnBtnOr()
{
    // TODO: Add your control notification handler code here
    m_BtnOH.EnableWindow(TRUE);
    m_BtnOR.EnableWindow(FALSE);

    if(nMode!=4)
    {
        XmlDatabase myDb;
        myDb.LoadFromFile("Online.xdb");

        if(nMode!=3)
            myDb.Insert("Account", (char *)(LPCTSTR)m_CalledNum);
        else
            myDb.Insert("Account", (char *)(LPCTSTR)m_CalledNum.Mid(5));

        myDb.SaveToFile();
    }

    bCalled=true;
    bStarted=true;
    dStart=Now();
}

BOOL EmuCall::OnInitDialog()
{
    CDialog::OnInitDialog();
    bCalled=false;
    bStarted=false;
    bDontSave=true;

    // TODO: Add extra initialization here
    XmlDatabase MyDB;
    MyDB.LoadFromFile("Account.xdb");

    for(unsigned int i=0; i<MyDB.size(); i++)
        m_ComboSelf.AddString(MyDB[i]["Account"].toString().c_str());

    RECT myRect;
    m_ComboSelf.GetWindowRect(&myRect);
    m_ComboSelf.SetWindowPos(NULL, 0, 0, myRect.right-myRect.left, 200, SWP_NOMOVE);

    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
}

void EmuCall::OnBtnOh()
{
    // TODO: Add your control notification handler code here
    dEnd=Now();
    bStarted=false;

    XmlDatabase myDb;
    myDb.LoadFromFile("Online.xdb");
    CString cCondition="Account='";
    cCondition+=m_CalledNum;
    cCondition+="'";

    myDb.Delete((char *)(LPCTSTR)cCondition);
    myDb.SaveToFile();

    m_BtnOH.EnableWindow(FALSE);
    m_BtnHH.EnableWindow(FALSE);
}

void EmuCall::OnBtnHh()
{
    // TODO: Add your control notification handler code here
    dEnd=Now();
    bStarted=false;
    m_BtnHH.EnableWindow(FALSE);
    m_BtnOH.EnableWindow(FALSE);

    XmlDatabase myDb;
    myDb.LoadFromFile("Online.xdb");
    CString cCondition="Account='";

    CString myString;
    m_ComboSelf.GetLBText(m_ComboSelf.GetCurSel(), myString);

    cCondition+=myString;
    cCondition+="'";

    myDb.Delete((char *)(LPCTSTR)cCondition);
    myDb.SaveToFile();
}

void EmuCall::OnSelchangeComboSelf()
{
    // TODO: Add your control notification handler code here
    XmlDatabase myDb;
    if(myDb.LoadFromFile("Online.xdb")==false)
    {
        myDb.AddColumn("Account", "String", "绰");
        myDb.SaveToFile();
    }

    CString myString;
    m_ComboSelf.GetLBText(m_ComboSelf.GetCurSel(), myString);

    CString cCondition="Account='";
    cCondition+=myString;
    cCondition+="'";

    if(myDb.Filter((char *)(LPCTSTR)cCondition, "Account").GetCount())
        MessageBox("úѱռã", "绰ѳ", MB_ICONINFORMATION);
    else
    {
        m_BtnHR.EnableWindow(m_ComboSelf.GetCurSel()>-1);
        myDb.Insert("Account", (char *)(LPCTSTR)myString);
        myDb.SaveToFile();
        m_ComboSelf.EnableWindow(FALSE);
        bDontSave=false;
    }
}

void EmuCall::OnClose()
{
    // TODO: Add your message handler code here and/or call default
    //绰

    if(bDontSave)
    {
        EndDialog(IDCANCEL);
        return;
    }

    if(bStarted)
        dEnd=Now();

    if(bCalled)
    {
        XmlDatabase dbTime;
        CString myString;
        double total=0;
        double dSum=0;
        double dIP=0;
        DateTime dTemp1, dTemp2;
        string szTemp;
        dbTime.LoadFromFile("Time.xdb");
        m_ComboSelf.GetLBText(m_ComboSelf.GetCurSel(), myString);
        switch(nMode)
        {
        case 1:
            dSum=(double)((dEnd-dStart)*24*60);
            dSum=dSum/3;
            if(dSum-(int)dSum>0) dSum+=1;
            total=((int)dSum)*0.18;
            break;
        case 2:
            dTemp1=dEnd;
            for(;dTemp1>dStart;)
            {
                CString szTTemp;
                szTTemp=dTemp1.getDate().c_str();
                szTTemp+=" 21:00:00";
                szTemp=(char *)(LPCTSTR)szTTemp;
                dTemp2.fromString((char *)szTemp.c_str());
                if(dTemp2<dStart) dTemp2=dStart;
                if(dTemp1>dTemp2)
                {
                    dSum=(double)((dTemp1-dTemp2)*24*60);
                    if(dSum-(int)dSum>0) dSum++;
                    total+=((int)dSum)*0.6;
                    dTemp1=dTemp2;
                }
                dTemp2.setHour(7);
                dTemp2.setMinute(0);
                dTemp2.setSecond(0);
                if (dTemp2<dStart) dTemp2=dStart;
                if(dTemp1>dTemp2)
                {
                    dSum=(double)((dTemp1-dTemp2)*24*60);
                    if(dSum-(int)dSum>0) dSum++;
                    if(dTemp2.getWeekday()==0||dTemp2.getWeekday()==6)
                        total+=((int)dSum)*0.6;
                    else
                        total+=((int)dSum)*1.1;
                    dTemp1=dTemp2;
                }
                dTemp2-=1;
                dTemp2.setHour(23);
                dTemp2.setMinute(59);
                dTemp2.setSecond(59);
                if(dTemp2<dStart) dTemp2=dStart;
                if(dTemp1>dTemp2)
                {
                    dSum=(double)((dTemp1-dTemp2)*24*60);
                    if(dSum-(int)dSum>0) dSum++;
                    total+=((int)dSum)*0.4;
                    dTemp1=dTemp2;
                }
            }
            break;
        case 3:
            dSum=(double)((dEnd-dStart)*24*60);
            dSum=dSum/3;
            if(dSum-(int)dSum>0) dSum+=1;
            total=((int)dSum)*0.18;
            dIP=(double)((dEnd-dStart)*24*60);
            if(dIP-(int)dIP>0) dIP+=1;
            total+=((int)dIP)*0.3;
            break;
        case 4:
            total=0;
            break;
        }
        //ݿ
        dbTime.Insert("Account",  (char *)(LPCTSTR)myString);
        dbTime[dbTime.size()-1]["ToNum"].fromString((char *)(LPCTSTR)m_CalledNum);
        dbTime[dbTime.size()-1]["StartTime"].fromString(dStart.toString());
        dbTime[dbTime.size()-1]["EndTime"].fromString(dEnd.toString());
        dbTime[dbTime.size()-1]["Cost"].fromNumber(total);
        dbTime.SaveToFile();
    }

    if(m_ComboSelf.GetCurSel()>-1)
    {
        XmlDatabase myDb;
        myDb.LoadFromFile("Online.xdb");
        CString cCondition="Account='";

        if(nMode!=3)
            cCondition+=m_CalledNum;
        else
            cCondition+=m_CalledNum.Mid(5);

        cCondition+="' or Account='";

        CString myString;
        m_ComboSelf.GetLBText(m_ComboSelf.GetCurSel(), myString);

        cCondition+=myString;
        cCondition+="'";

        myDb.Delete((char *)(LPCTSTR)cCondition);
        myDb.SaveToFile();
    }

    EndDialog(IDCANCEL);
}

BOOL EmuCall::OnCommand(WPARAM wParam, LPARAM lParam)
{
    // TODO: Add your specialized code here and/or call the base class

    switch(wParam)
    {
    case IDOK://ػس
        return true;
    case IDCANCEL://ESC
        OnClose();
        return true;
    default://Ϣأ
        return CDialog::OnCommand(wParam, lParam);
    }
}
