// Query.cpp : implementation file
//

#include "stdafx.h"
#include "TeleMan.h"
#include "Query.h"

#include "Result.h"

#include "XmlPd.h"
#include "FRadioB.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Query dialog


Query::Query(CWnd* pParent /*=NULL*/)
    : CDialog(Query::IDD, pParent)
{
    //{{AFX_DATA_INIT(Query)
    //}}AFX_DATA_INIT
}


void Query::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(Query)
    DDX_Control(pDX, IDC_COMBO, m_ComboAccount);
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Query, CDialog)
    //{{AFX_MSG_MAP(Query)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Query message handlers

void Query::OnOK()
{
    // TODO: Add extra validation here
    Result dlg;

    CString myString;
    m_ComboAccount.GetLBText(m_ComboAccount.GetCurSel(), myString);
    if(myString=="(û)")
        myString="";

    dlg.szQuery=myString;
    dlg.bThisMonth=(rThisMonth.Check()!=FALSE);
    dlg.DoModal();
    EndDialog(IDOK);
}

BOOL Query::OnInitDialog()
{
    CDialog::OnInitDialog();

    // TODO: Add extra initialization here
    XmlDatabase myDb;
    myDb.LoadFromFile("Account.xdb");

    m_ComboAccount.AddString("(û)");
    for(unsigned int i=0; i<myDb.size(); i++)
        m_ComboAccount.AddString(myDb[i]["Account"].toString().c_str());

    RECT myRect;
    m_ComboAccount.GetWindowRect(&myRect);
    m_ComboAccount.SetWindowPos(NULL, 0, 0, myRect.right-myRect.left, 200, SWP_NOMOVE);

    rThisMonth.AttachRadio(GetDlgItem(IDC_RADIO_THIS)->m_hWnd);
    rLastMonth.AttachRadio(GetDlgItem(IDC_RADIO_LAST)->m_hWnd);
    rThisMonth.Check(TRUE);

    m_ComboAccount.SetCurSel(0);
    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
}
