// AccMan.cpp : implementation file
//

#include "stdafx.h"
#include "TeleMan.h"
#include "AccMan.h"
#include "Modify.h"
#include "/Ctc/XmlDb.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AccMan dialog


AccMan::AccMan(CWnd* pParent /*=NULL*/)
    : CDialog(AccMan::IDD, pParent)
{
    //{{AFX_DATA_INIT(AccMan)
        // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}


void AccMan::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(AccMan)
    DDX_Control(pDX, IDC_BUTTON_DEL, m_BtnDel);
    DDX_Control(pDX, IDC_LIST, m_List);
    DDX_Control(pDX, IDC_BTN_MODIFY, m_BtnModify);
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(AccMan, CDialog)
    //{{AFX_MSG_MAP(AccMan)
    ON_LBN_SELCHANGE(IDC_LIST, OnSelchangeList)
    ON_BN_CLICKED(IDC_BTN_MODIFY, OnBtnModify)
    ON_WM_CLOSE()
    ON_LBN_DBLCLK(IDC_LIST, OnDblclkList)
    ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
    ON_BN_CLICKED(IDC_BUTTON_DEL, OnButtonDel)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// AccMan message handlers

BOOL AccMan::OnInitDialog()
{
    CDialog::OnInitDialog();

    // TODO: Add extra initialization here
    XmlDatabase MyDB;
    MyDB.LoadFromFile("Account.xdb");
    for(unsigned int i=0; i<MyDB.size(); i++)
        m_List.AddString((char *)MyDB[i]["Account"].toString().c_str());

    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
}

void AccMan::OnSelchangeList()
{
    // TODO: Add your control notification handler code here
    m_BtnModify.EnableWindow(m_List.GetCurSel()>-1);
    m_BtnDel.EnableWindow(m_List.GetCurSel()>-1);
}

void AccMan::OnBtnModify()
{
    // TODO: Add your control notification handler code here
    Modify dlg;
    XmlDatabase MyDB;
    int i;
    bool flag=true;
    MyDB.LoadFromFile("Account.xdb");
    dlg.m_Address=MyDB[m_List.GetCurSel()]["Address"].toString().c_str();
    dlg.m_Name=MyDB[m_List.GetCurSel()]["UserName"].toString().c_str();
    dlg.m_Phone=MyDB[m_List.GetCurSel()]["Account"].toString().c_str();

    if(dlg.DoModal()==IDOK)
    {
        if(dlg.m_Phone[0]=='0')
        {
            MessageBox("ӳ;룡", "绰Ʒѳ", MB_ICONINFORMATION);
            return;
        }

        for(i=0; i<dlg.m_Phone.GetLength(); i++)
        {
            if(dlg.m_Phone[i]<'0'||dlg.m_Phone[i]>'9')
            {
                MessageBox("绰ȫ֣", "绰Ʒѳ", MB_ICONINFORMATION);
                flag=false;
                break;
            }
        }

        for(i=0; i<MyDB.size(); i++)
        {
            if(dlg.m_Phone==MyDB[i]["Account"].toString().c_str()&&i!=m_List.GetCurSel())
            {
                MessageBox("õ绰Ѵڣ", "绰Ʒѳ", MB_ICONINFORMATION);
                flag=false;
                break;
            }
        }

        XmlDatabase myDb;
        myDb.LoadFromFile("FreeCall.xdb");
        CString cCondition="Account='";
        cCondition+=dlg.m_Phone;
        cCondition+="'";

        if(myDb.Filter((char *)(LPCTSTR)cCondition, "Account").GetCount())
        {
            MessageBox("õ绰Ѵڣ", "绰Ʒѳ", MB_ICONINFORMATION);
            flag=false;
            return;
        }

        if(dlg.m_Name==""||dlg.m_Address==""||dlg.m_Phone=="")
        {
            MessageBox("ûַ͵绰벻Ϊգ", "绰Ʒѳ", MB_ICONINFORMATION);
            flag=false;
        }

        if(flag)
        {
            MyDB[m_List.GetCurSel()]["UserName"].fromString((char *)(LPCTSTR)dlg.m_Name);
            MyDB[m_List.GetCurSel()]["Account"].fromString((char *)(LPCTSTR)dlg.m_Phone);
            MyDB[m_List.GetCurSel()]["Address"].fromString((char *)(LPCTSTR)dlg.m_Address);
            MyDB.SaveToFile();
            m_List.InsertString(m_List.GetCurSel(), (char *)(LPCTSTR)dlg.m_Phone);
            m_List.DeleteString(m_List.GetCurSel());
        }
    }
}

void AccMan::OnClose()
{
    // TODO: Add your message handler code here and/or call default
    XmlDatabase MyDB;
    CDialog::OnClose();
}

void AccMan::OnDblclkList()
{
    // TODO: Add your control notification handler code here
    OnBtnModify();
}

void AccMan::OnButtonAdd()
{
    // TODO: Add your control notification handler code here
    Modify dlg;
    XmlDatabase MyDB;
    MyDB.LoadFromFile("Account.xdb");

    if(dlg.DoModal()==IDOK)
    {
        int i=0;
        bool flag=true;

        if(dlg.m_Phone[0]=='0')
        {
            MessageBox("ӳ;룡", "绰Ʒѳ", MB_ICONINFORMATION);
            return;
        }

        for(i=0; i<dlg.m_Phone.GetLength(); i++)
        {
            if(dlg.m_Phone[i]<'0'||dlg.m_Phone[i]>'9')
            {
                MessageBox("绰ȫ֡", "绰Ʒѳ", MB_ICONINFORMATION);
                flag=false;
                break;
            }
        }

        for(i=0; i<MyDB.size(); i++)
        {
            if(dlg.m_Phone==MyDB[i]["Account"].toString().c_str())
            {
                MessageBox("õ绰Ѵڣ", "绰Ʒѳ", MB_ICONINFORMATION);
                flag=false;
                break;
            }
        }

        XmlDatabase myDb;
        myDb.LoadFromFile("FreeCall.xdb");
        CString cCondition="Account='";
        cCondition+=dlg.m_Phone;
        cCondition+="'";

        if(myDb.Filter((char *)(LPCTSTR)cCondition, "Account").GetCount())
        {
            MessageBox("õ绰Ѵڣ", "绰Ʒѳ", MB_ICONINFORMATION);
            flag=false;
            return;
        }

        if(dlg.m_Name==""||dlg.m_Address==""||dlg.m_Phone=="")
        {
            MessageBox("ûַ͵绰벻Ϊա", "绰Ʒѳ", MB_ICONINFORMATION);
            flag=false;
        }

        if(flag)
        {
            MyDB.Insert("UserName",(char *)(LPCTSTR)dlg.m_Name);
            MyDB[MyDB.size()-1]["Account"].fromString((char *)(LPCTSTR)dlg.m_Phone);
            MyDB[MyDB.size()-1]["Address"].fromString((char *)(LPCTSTR)dlg.m_Address);
            MyDB.SaveToFile();
            m_List.AddString(dlg.m_Phone);
        }
    }
}

void AccMan::OnButtonDel()
{
    // TODO: Add your control notification handler code here
    XmlDatabase MyDB;
    if(MyDB.LoadFromFile("Account.xdb")==false)
    {
        MyDB.AddColumn("Account", "String", "绰");
        MyDB.AddColumn("UserName", "String", "û");
        MyDB.AddColumn("Address", "String", "סַ");
    }
    else MyDB.Delete(m_List.GetCurSel());
    MyDB.SaveToFile();
    m_List.DeleteString(m_List.GetCurSel());

    m_BtnModify.EnableWindow(FALSE);
    m_BtnDel.EnableWindow(FALSE);
}
