// Result.cpp : implementation file
//

#include "stdafx.h"
#include "TeleMan.h"
#include "Result.h"

#include "XmlPd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Result dialog


Result::Result(CWnd* pParent /*=NULL*/)
    : CDialog(Result::IDD, pParent)
{
    //{{AFX_DATA_INIT(Result)
        // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}


void Result::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(Result)
    DDX_Control(pDX, IDC_EDIT, m_EditResult);
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Result, CDialog)
    //{{AFX_MSG_MAP(Result)
    ON_WM_SIZE()
    ON_COMMAND(IDM_RESULT_SAVEAS, OnResultSaveas)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Result message handlers

void Result::OnSize(UINT nType, int cx, int cy)
{
    CDialog::OnSize(nType, cx, cy);

    // TODO: Add your message handler code here
    if(::IsWindow(m_EditResult.m_hWnd))
        m_EditResult.MoveWindow(0, 0, cx, cy);
}

BOOL Result::OnInitDialog()
{
    CDialog::OnInitDialog();

    // TODO: Add extra initialization here
    HICON m_BigIcon;
    HICON m_SmallIcon;

    m_BigIcon  =(HICON)LoadImage(AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDI_ICON_RESULT), IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR);
    m_SmallIcon=(HICON)LoadImage(AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDI_ICON_RESULT), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);

    SetIcon(m_BigIcon, TRUE);            // Set big icon
    SetIcon(m_SmallIcon, FALSE);        // Set small icon

    unsigned int i;
    CString szResult;
    string szBuffer;

    if(szQuery.GetLength())
    {
        szBuffer.resize(1000);
        sprintf((char *)szBuffer.c_str(), "û%s»嵥£\r\n\r\n", (char *)(LPCTSTR)szQuery);
        szResult=szBuffer.c_str();

        m_EditResult.SetWindowText(szQuery);
        XmlDatabase myDb;
        myDb.LoadFromFile("Time.xdb");
        double dSum=0;

        CString szQueryString="Account='";
        szQueryString+=szQuery;
        szQueryString+="' and StartTime>#";

        DateTime dTemp;

        if(bThisMonth==false)
        {
            if(dTemp.getMonth()>1)
                dTemp.setMonth(dTemp.getMonth()-1);
            else
            {
                dTemp.setMonth(12);
                dTemp.setYear(dTemp.getYear()-1);
            }
        }
        dTemp.setDay(1);

        szQueryString+=dTemp.getDate().c_str();
        szQueryString+="# and EndTime<#";

        dTemp.setDay(31);
        szQueryString+=dTemp.getDate().c_str();
        szQueryString+="#";

        RecordSet mySet=myDb.Filter((char *)(LPCTSTR)szQueryString, "Account");

        for(i=0; i<mySet.GetCount(); i++)
        {
            szBuffer.resize(1000);
            sprintf((char *)szBuffer.c_str(), "%19s  %19s %s %5.2f\r\n",
                mySet[i]["StartTime"].toString().c_str(),
                mySet[i]["EndTime"].toString().c_str(),
                mySet[i]["ToNum"].toString().c_str(),
                mySet[i]["Cost"].toNumber());
            szResult+=szBuffer.c_str();
            dSum+=mySet[i]["Cost"].toNumber();
        }

        szResult+="ѣ38.00";
        dSum+=38.0;
        szBuffer.resize(1000);
        sprintf((char *)szBuffer.c_str(), "\r\nƷã%6.2f", dSum);
        szResult+=szBuffer.c_str();
    }
    else
    {
        double dTotal=0;

        XmlDatabase dbTime;
        dbTime.LoadFromFile("Time.xdb");
        XmlDatabase dbAccount;
        dbAccount.LoadFromFile("Account.xdb");

        CString szQueryString="StartTime>#";

        DateTime dTemp;
        if(bThisMonth==false)
        {
            if(dTemp.getMonth()>1)
                dTemp.setMonth(dTemp.getMonth()-1);
            else
            {
                dTemp.setMonth(12);
                dTemp.setYear(dTemp.getYear()-1);
            }
        }
        dTemp.setDay(1);

        szQueryString+=dTemp.getDate().c_str();
        szQueryString+="# and EndTime<#";

        dTemp.setDay(31);
        szQueryString+=dTemp.getDate().c_str();
        szQueryString+="# and Account='";

        for(i=0; i<dbAccount.size(); i++)
        {
            szBuffer.resize(1000);
            double dSum=0;
            RecordSet mySet=dbTime.Filter((char *)(LPCTSTR)(szQueryString+dbAccount[i]["Account"].toString().c_str()+"'"), "Account");
            for(unsigned int j=0; j<mySet.GetCount(); j++)
                dSum+=mySet[j]["Cost"].toNumber();
            dSum+=38.0;

            dTotal+=dSum;
            sprintf((char *)szBuffer.c_str(), "û%10s(%10s) »ܼƣ%6.2fԪ\r\n", dbAccount[i]["UserName"].toString().c_str(), dbAccount[i]["Account"].toString().c_str(), dSum);
            szResult+=szBuffer.c_str();
        }

        szBuffer.resize(1000);
        sprintf((char *)szBuffer.c_str(), "\r\n룺%8.2f", dTotal);
        szResult+=szBuffer.c_str();
    }

    m_EditResult.SetWindowText(szResult);
    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
}

void Result::OnResultSaveas()
{
    // TODO: Add your command handler code here
    CFileDialog m_SaveDlg(FALSE,"txt",NULL,OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_OVERWRITEPROMPT,"ıļ(*.txt)|*.txt|ļ|*.*||");

    if(m_SaveDlg.DoModal()==IDOK)
    {
        fstream myStream;
        myStream.open((char *)(LPCTSTR)m_SaveDlg.GetPathName(), ios::out);

        if(myStream.good())
        {
            CString buffer;
            m_EditResult.GetWindowText(buffer);
            myStream<<(char *)(LPCTSTR)buffer;
        }
        else
            MessageBox("ļʧܣ", "绰Ƿѳ", MB_ICONINFORMATION);
    }
}
